// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package operator_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// GetDirectPVDriveListOKCode is the HTTP code returned for type GetDirectPVDriveListOK
const GetDirectPVDriveListOKCode int = 200

/*
GetDirectPVDriveListOK A successful response.

swagger:response getDirectPVDriveListOK
*/
type GetDirectPVDriveListOK struct {

	/*
	  In: Body
	*/
	Payload *models.GetDirectPVDriveListResponse `json:"body,omitempty"`
}

// NewGetDirectPVDriveListOK creates GetDirectPVDriveListOK with default headers values
func NewGetDirectPVDriveListOK() *GetDirectPVDriveListOK {

	return &GetDirectPVDriveListOK{}
}

// WithPayload adds the payload to the get direct p v drive list o k response
func (o *GetDirectPVDriveListOK) WithPayload(payload *models.GetDirectPVDriveListResponse) *GetDirectPVDriveListOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get direct p v drive list o k response
func (o *GetDirectPVDriveListOK) SetPayload(payload *models.GetDirectPVDriveListResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetDirectPVDriveListOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetDirectPVDriveListDefault Generic error response.

swagger:response getDirectPVDriveListDefault
*/
type GetDirectPVDriveListDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetDirectPVDriveListDefault creates GetDirectPVDriveListDefault with default headers values
func NewGetDirectPVDriveListDefault(code int) *GetDirectPVDriveListDefault {
	if code <= 0 {
		code = 500
	}

	return &GetDirectPVDriveListDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get direct p v drive list default response
func (o *GetDirectPVDriveListDefault) WithStatusCode(code int) *GetDirectPVDriveListDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get direct p v drive list default response
func (o *GetDirectPVDriveListDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get direct p v drive list default response
func (o *GetDirectPVDriveListDefault) WithPayload(payload *models.Error) *GetDirectPVDriveListDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get direct p v drive list default response
func (o *GetDirectPVDriveListDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetDirectPVDriveListDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
